﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Threading.Tasks;

namespace EchoTcpServerWithHelper
{
    public class EchoServer
    {
        public int Port { get; }
        public IPAddress LocalAddress { get; }

        public EchoServer(int port)
        {
            Port = port;
            LocalAddress = IPAddress.Parse("127.0.0.1");
            //LocalAddress = IPAddress.Loopback;

            //string hostName = Dns.GetHostName();
            //IPHostEntry s = Dns.GetHostEntry(hostName);
            //LocalAddress = s.AddressList[0];
            //IPAddress localAddress = Dns.GetHostEntry("127.0.0.1");
        }

        public void Start()
        {
            // https://msdn.microsoft.com/en-us/library/system.net.sockets.tcplistener.aspx
            TcpListener server = new TcpListener(LocalAddress, Port);
            server.Start();
            Console.WriteLine("Echo TCP server started on " + LocalAddress + " port " + Port);
            while (true)
            {
                Console.WriteLine("Waiting for connection ...");
                TcpClient client = server.AcceptTcpClient();
                Console.WriteLine("Connected!");
                ConnectionHandler handler = new ConnectionHandler(client);
                Task.Run(() => handler.DoIt());
            }
        }
    }
}
