﻿using System.IO;
using System.Net.Sockets;
using EchoTcpServerWithHelper;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace UnitTestProject1
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void TestEchoServer()
        {
            string request = "Hello world";
            string response = GetResponse(request);
            Assert.AreEqual(request, response);

            request = "";
            response = GetResponse(request);
            Assert.AreEqual(request, response);
        }

        private static string GetResponse(string request)
        {
            string server = "localhost"; // Dns.GetHostName();
            using (TcpClient client = new TcpClient(server, Program.Port))
            {
                NetworkStream stream = client.GetStream();
                StreamWriter writer = new StreamWriter(stream);
                writer.WriteLine(request);
                writer.Flush();
                StreamReader reader = new StreamReader(stream);
                string response = reader.ReadLine();
                return response;
            }
        }
    }
}
